#ifndef __PLASP__SAS__GOAL_H
#define __PLASP__SAS__GOAL_H

#include <plasp/input/Parser.h>
#include <plasp/sas/AssignedVariable.h>

namespace plasp
{
namespace sas
{

////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Goal
//
////////////////////////////////////////////////////////////////////////////////////////////////////

class Goal
{
	public:
		using Fact = AssignedVariable;
		using Facts = AssignedVariables;

		static Goal fromSAS(input::Parser<> &parser, const Variables &variables);

	public:
		const Facts &facts() const;

	private:
		Goal() = default;

		Facts m_facts;
};

////////////////////////////////////////////////////////////////////////////////////////////////////

}
}

#endif
